#ifndef __ILI93XX_H
#define __ILI93XX_H
#include <stm32f10x_lib.h>		
#include "sys.h"	 
#include "stdlib.h"

/*********************************************************************************************************
ģݽṹ
*********************************************************************************************************/
typedef struct typefnt{                                                 /* ģݽṹ             */
    unsigned char Index[2];                                             /*                  */
    unsigned char Msk[32];                                              /*                    */
}FNT_GB16;

extern const FNT_GB16 GBHZ_16[];                                        /* Զ庺ֿ               */
extern const unsigned char ASCII[][16];                                 /* ԶASCIIֿ              */

extern u16 findHzIndex(u8 *hz);
//2궨壬ĻʾʽIOٶ
#define USE_HORIZONTAL  //Ƿʹú
#define LCD_FAST_IO  //ǷʹÿIO
#ifdef USE_HORIZONTAL
#define MAX_CHAR_POSX 312
#define MAX_CHAR_POSY 232 
#else     
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 312
#endif

//////////////////////////////////////////////////////////////////////////////////	 
//TFTLCDҪõĺ		   
extern u16  POINT_COLOR;//ĬϺɫ    
extern u16  BACK_COLOR; //ɫ.ĬΪɫ

//LCDĳߴ
#ifdef USE_HORIZONTAL
#define LCD_W 320
#define LCD_H 240
#else
#define LCD_W 240
#define LCD_H 320
#endif
////////////////////////////////////////////////////////////////////
//-----------------LCD˿ڶ---------------- 
#define	LCD_LED PCout(12) //LCD    		 PC12 
//ʹÿIO¾䣬ʹãȥɣ
//ʹÿIOˢʿԴﵽ28֡ÿ룡
//ͨIOֻ14֡ÿ룡   

#ifdef LCD_FAST_IO //IO

#define	LCD_CS_SET  GPIOC->BSRR=1<<9    //Ƭѡ˿  	     PC8
#define	LCD_RS_SET	GPIOC->BSRR=1<<8    ///          PC9	   
#define	LCD_WR_SET	GPIOC->BSRR=1<<10    //д			 PC10
#define	LCD_RD_SET	GPIOC->BSRR=1<<11    //			 PC11
								    
#define	LCD_CS_CLR  GPIOC->BRR=1<<9     //Ƭѡ˿  	     PC8
#define	LCD_RS_CLR	GPIOC->BRR=1<<8     ///          PC9	   
#define	LCD_WR_CLR	GPIOC->BRR=1<<10     //д			 PC10
#define	LCD_RD_CLR	GPIOC->BRR=1<<11     //			 PC11
								    
#else //IO

#define	LCD_CS	PCout(9)  //Ƭѡ˿  	     PC8
#define	LCD_RS	PCout(8)  ///        PC9	   
#define	LCD_WR	PCout(10)  //д			 PC10
#define	LCD_RD	PCout(11)  //			 PC11
								    
#endif	  
//PC0~7,PB8-PB15Ϊ //  
#define DATAOUT(data){\
GPIOC->ODR=((GPIOC->ODR&0xff00)|(data&0x00ff));\
GPIOB->ODR=((GPIOB->ODR&0x00FF)|(data&0xff00));\
}
#define DATAIN     (GPIOC->IDR&0x00FF)|(GPIOB->IDR&0xff00);   //
//////////////////////////////////////////////////////////////////////
//ɫ
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define BRED             0XF81F
#define GRED 			 0XFFE0
#define GBLUE			 0X07FF
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
//GUIɫ

#define DARKBLUE      	 0X01CF	//ɫ
#define LIGHTBLUE      	 0X7D7C	//ǳɫ  
#define GRAYBLUE       	 0X5458 //ɫ
//ɫΪPANELɫ 
 
#define LIGHTGREEN     	 0X841F //ǳɫ
//#define LIGHTGRAY        0XEF5B //ǳɫ(PANNEL)
#define LGRAY 			 0XC618 //ǳɫ(PANNEL),屳ɫ

#define LGRAYBLUE        0XA651 //ǳɫ(мɫ)
#define LBBLUE           0X2B12 //ǳɫ(ѡĿķɫ)
	    															  
extern u16 BACK_COLOR, POINT_COLOR ;  
void LCD_Init(void);
void LCD_DisplayOn(void);//ʾ
void LCD_DisplayOff(void);//رʾ
void LCD_Clear(u16 Color);//Ҫɫ	 
void LCD_SetCursor(u16 Xpos, u16 Ypos);//ùλ
void LCD_DrawPoint(u16 x,u16 y);//
u16  LCD_ReadPoint(u16 x,u16 y); //
void Draw_Circle(u16 x0,u16 y0,u8 r);//Բx0y0Բģr뾶
void LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2);//x1,y1;x2,y2յ
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2);//x1y1,x2y2ΪԽʼ		   
void LCD_Fill(u16 xsta,u16 ysta,u16 xend,u16 yend,u16 color);//ָ(xend-xsta)*(yend-ysta)
u16 WriteOneASCII(u8 *pucMsk,u16 x0,u16 y0,u16 color);//ʾһASCIIַ
void LCD_ShowChar(u16 x,u16 y,u8 num,u8 size,u8 mode);//ʾһַ
void LCD_ShowNum(u16 x,u16 y,u32 num,u8 len,u8 size);  //ʾһ,xy,numʾ,size,С,lenλ
void LCD_Show2Num(u16 x,u16 y,u16 num,u8 len,u8 size,u8 mode);//ʾ2xy,numʾ,size,С,lenλmodģʽ
void LCD_ShowString(u16 x,u16 y,const u8 *p,u8 size,u8 mod);		 //ʾһַ,16
void ili9320_DrawPicture(u16 StartX,u16 StartY,u16 EndX,u16 EndY,u16 *pic);//ʾͼƬ picͼƬͷָ
u16 findHzIndex(u8 *hz);//ѰҺֿλ
void Show_OneHZ(u8 x,u8 y,u8 *font,u8 size,u8 mode);
void Show_Str_hz(u8 x,u8 y,u8*str,u8 size,u8 mode);
void DrawPicture_display(u16 x,u16 y,u16 width,u16 height,u16 *PictureAddr);
									    
void LCD_WriteReg(u8 LCD_Reg, u16 LCD_RegValue);//дĴ
u16 LCD_ReadReg(u8 LCD_Reg);//Ĵ
void LCD_WriteRAM_Prepare(void);//ʼдGRAMַ
void LCD_WriteRAM(u16 RGB_Code);//ʼдGRAM
u16 LCD_ReadRAM(void);		   


//ú궨,ٶ.
#ifdef LCD_FAST_IO //IO
//д8λݺ
#define LCD_WR_DATA(data){\
LCD_RS_SET;\
LCD_CS_CLR;\
DATAOUT(data);\
LCD_WR_CLR;\
LCD_WR_SET;\
LCD_CS_SET;\
}
////дĴ
#define LCD_WR_REG(data){\
LCD_RS_CLR;\
LCD_CS_CLR;\
LCD_WR_CLR;\
DATAOUT(data);\
LCD_WR_SET;\
LCD_CS_SET;\
} 
#else//IO
#define LCD_WR_DATA(data){\
LCD_RS=1;\
LCD_CS=0;\
DATAOUT(data);\
LCD_WR=0;\
LCD_WR=1;\
LCD_CS=1;\
}
//дĴ
#define LCD_WR_REG(data){\
LCD_RS=0;\
LCD_CS=0;\
DATAOUT(data);\
LCD_WR=0;\
LCD_WR=1;\
LCD_CS=1;\
} 	
#endif																				 
//9320/9325 LCDĴ  
#define R0             0x00
#define R1             0x01
#define R2             0x02
#define R3             0x03
#define R4             0x04
#define R5             0x05
#define R6             0x06
#define R7             0x07
#define R8             0x08
#define R9             0x09
#define R10            0x0A
#define R12            0x0C
#define R13            0x0D
#define R14            0x0E
#define R15            0x0F
#define R16            0x10
#define R17            0x11
#define R18            0x12
#define R19            0x13
#define R20            0x14
#define R21            0x15
#define R22            0x16
#define R23            0x17
#define R24            0x18
#define R25            0x19
#define R26            0x1A
#define R27            0x1B
#define R28            0x1C
#define R29            0x1D
#define R30            0x1E
#define R31            0x1F
#define R32            0x20
#define R33            0x21
#define R34            0x22
#define R36            0x24
#define R37            0x25
#define R40            0x28
#define R41            0x29
#define R43            0x2B
#define R45            0x2D
#define R48            0x30
#define R49            0x31
#define R50            0x32
#define R51            0x33
#define R52            0x34
#define R53            0x35
#define R54            0x36
#define R55            0x37
#define R56            0x38
#define R57            0x39
#define R59            0x3B
#define R60            0x3C
#define R61            0x3D
#define R62            0x3E
#define R63            0x3F
#define R64            0x40
#define R65            0x41
#define R66            0x42
#define R67            0x43
#define R68            0x44
#define R69            0x45
#define R70            0x46
#define R71            0x47
#define R72            0x48
#define R73            0x49
#define R74            0x4A
#define R75            0x4B
#define R76            0x4C
#define R77            0x4D
#define R78            0x4E
#define R79            0x4F
#define R80            0x50
#define R81            0x51
#define R82            0x52
#define R83            0x53
#define R96            0x60
#define R97            0x61
#define R106           0x6A
#define R118           0x76
#define R128           0x80
#define R129           0x81
#define R130           0x82
#define R131           0x83
#define R132           0x84
#define R133           0x85
#define R134           0x86
#define R135           0x87
#define R136           0x88
#define R137           0x89
#define R139           0x8B
#define R140           0x8C
#define R141           0x8D
#define R143           0x8F
#define R144           0x90
#define R145           0x91
#define R146           0x92
#define R147           0x93
#define R148           0x94
#define R149           0x95
#define R150           0x96
#define R151           0x97
#define R152           0x98
#define R153           0x99
#define R154           0x9A
#define R157           0x9D
#define R192           0xC0
#define R193           0xC1
#define R229           0xE5							  		 
#endif  
	 
	 



